require 'sketchup.rb'
def gcd3(one,other)
	min = one.abs
	max = other.abs
	min, max = max % min, min while (min > 0)
	max
end
def retrieve_selection(extra)
	selection = Sketchup.active_model.selection
	side = []
	sides = []
	alledges = []
	selection.each {|looptemp| alledges.push(looptemp)}
	allelse = alledges.reject{|looptemp| looptemp.typename == "Edge"}#extract construction points from this
	alledges.reject!{|looptemp| looptemp.typename != "Edge"}
	while (alledges.length > 0)
		side.push(alledges.pop)
		side.each do
			|looptemp|
			looptemp.vertices.each do
				|loopt|
				(loopt.edges & alledges).each do
					|lpt|
					side.push lpt
					alledges.delete lpt
				end
			end
		end
		sides.push(Array.new(side))
		side.clear
	end
	return sides.push(allelse) if extra
	return sides
end
def organize(startpoint, lines)
	if (startpoint != nil)
		points = [startpoint]
	else
		points = [lines.collect{|looptemp|looptemp.vertices}.flatten.uniq.reject{|looptemp|looptemp.edges.length > 1}[0]]
		points = lines[0] if (lines[0] == nil)
	end
	points.push(((lines.delete((points.last.edges & lines)[0])).vertices.reject{|looptemp|looptemp == points.last})[0]) while ((points.last.edges & lines).length != 0)
	return(points.collect{|looptemp|looptemp.position})
end
def clean_selection(entities)
	Sketchup.active_model.start_operation "Clean Selection"
	selection = Sketchup.active_model.selection
	if (entities)
		selection.clear
		selection.add entities
	end
	selection.each {|looptemp|looptemp.erase! if (looptemp.typename == "Edge" && looptemp.faces.length == 0)}
	selection.each {|looptemp|looptemp.erase! if (looptemp.typename == "Edge" && looptemp.faces.length == 2 && looptemp.faces[0].material == looptemp.faces[1].material && looptemp.faces[0].normal.parallel?(looptemp.faces[1].normal))}
	Sketchup.active_model.commit_operation
	return entities
end
def multiply_points(points, amount)
	addpoints = []
	(points.length - 1).times do
		|index|
		addpoints.push []
		(amount - 1).times do
			|number|
			addpoints.last.push(Geom::Point3d.linear_combination((amount - number - 1)/amount.to_f, points[index], (number + 1)/amount.to_f, points[index + 1]))
		end
	end
	points = points.zip addpoints
	points.flatten!
	points.pop
	return points
end
def evenize_points(points, length)
	temp = Array.new(points)
	temp.shift
	points.pop
	points = points.zip(temp)
	length = points.sort{|a, b|a[0].distance(a[1]) <=> b[0].distance(b[1])}[0] if(length == nil)
	length = length[0].distance length[1] if(length == nil)
	points.collect! do
		|looptemp|
		if (looptemp[0].distance(looptemp[1]) < length*2)
			looptemp
		else
			multiply_points(looptemp, (looptemp[0].distance(looptemp[1])/length).truncate)
		end
	end
	points.flatten!
	points.uniq!
	return points
end
def prep(choosing)
	Sketchup.active_model.start_operation "Edge Slicing"
	sides = retrieve_selection(false)
	sides.collect!{|looptemp|organize(looptemp[0].vertices[0], looptemp)}
	if choosing
		length = sides.flatten.sort{|a, b|a[0].distance(a[1]) <=> b[0].distance(b[1])}[0]
		length = length[0].distance length[1]
		sides.collect!{|looptemp|evenize_points(looptemp, length)}
	elsif (sides.length == 1)
		sides.collect!{|looptemp|multiply_points(looptemp, UI.inputbox(["Slice Amount"])[0].to_i)}
	else
		a = 1
		sides.each{|looptemp|a = a*(looptemp.length-1)}
		mult = sides[0].length-1
		sides.each{|looptemp|mult = gcd3(mult, (looptemp.length-1))}
		mult = a/mult
		puts mult
		sides.collect!{|looptemp|multiply_points(looptemp, mult/(looptemp.length-1))}
		#get overall lcd
		#multiply all sides to it
	end
	temp = nil
	sides.each do
		|looptemp|
		temp = Array.new(looptemp)
		temp.shift
		looptemp.pop
		looptemp = looptemp.zip temp
		looptemp.each{|loopt|Sketchup.active_model.selection.add(Sketchup.active_model.entities.add_edges(loopt[0], loopt[1]))}
	end
	Sketchup.active_model.commit_operation
end
def attach(leftpoints, rightpoints, choosing, reverse)
	Sketchup.active_model.start_operation "Skin Part"
	thesefaces = []
	rightpoints.reverse! if ((rightpoints.first.distance(leftpoints.first) > rightpoints.last.distance(leftpoints.first) && reverse == nil) || reverse == true)
	leftpos = 0
	0.upto(rightpoints.length - 2) do
		|looptemp|
		while (leftpoints[leftpos + 1] != nil && ((looptemp.to_f/(rightpoints.length - 1)*(leftpoints.length.truncate - 1) > leftpos && choosing == false)||(rightpoints[looptemp + 1].distance(leftpoints[leftpos]) > rightpoints[looptemp].distance(leftpoints[leftpos + 1]) && choosing)))
			thesefaces.push([rightpoints[looptemp], leftpoints[leftpos], leftpoints[leftpos + 1]])
			leftpos += 1
		end
		thesefaces.push([rightpoints[looptemp], leftpoints[leftpos], rightpoints[looptemp + 1]])
	end
	leftpos.upto(leftpoints.length - 2){|looptemp|thesefaces.push([rightpoints.last, leftpoints[looptemp], leftpoints[looptemp + 1]])}
	thesefaces.collect!{|looptemp|Sketchup.active_model.entities.add_face(looptemp)}
	return thesefaces
end
def skin(choosing)
	all = []
	sides = retrieve_selection(false)#change arg to true sometime
	#puts sides
	sides.collect! do
		|looptemp|
		if (looptemp.collect{|loopt|loopt.vertices}.flatten.uniq.reject{|loopt|loopt.edges.length != 1}.length == 2)
			organize(nil, looptemp)
		else
			organize(looptemp.collect{|loopt|loopt.vertices}.flatten.uniq.sort{|a, b|(b.position.x + b.position.y + b.position.z)<=>(a.position.x + a.position.y + a.position.z)}[0], looptemp)
		end
	end
	sides.unshift(sides.delete(sides.sort{|a, b|Geom::BoundingBox.new.add(a).center.distance([0, 0, 0]) <=> Geom::BoundingBox.new.add(b).center.distance([0, 0, 0])}.last))
	sidesets = []
	sides.sort!{|a,b|Geom::BoundingBox.new.add(a).center.distance(sides[0][0]) <=> Geom::BoundingBox.new.add(b).center.distance(sides[0][0])}
	0.upto(sides.length - 2){|looptemp|sidesets.push([sides[looptemp], sides[looptemp + 1]])}
	#curves memorize
	sidesets.each do
		|looptemp|
		all.push attach(looptemp[0], looptemp[1], choosing, nil)
		if (UI.messagebox("Is this connection done right?", MB_YESNO, "Quality Check") == 7 && UI.messagebox("Shall I try to fix my error?", MB_YESNO, "Answer, Please") == 6)
			all.pop
			Sketchup.undo
			all.push attach(looptemp[0], looptemp[1], choosing, true)
			if (UI.messagebox("Is this connection done right?", MB_YESNO, "Quality Check") == 7 && UI.messagebox("Shall I try to fix my error?", MB_YESNO, "Answer, Please") == 6)
				all.pop
				Sketchup.undo
				all.push attach(looptemp[0], looptemp[1], choosing, false)
			end
		end
	end
	all.flatten!
	all.each{|looptemp|Sketchup.active_model.selection.add(looptemp.edges)}
	Sketchup.active_model.selection.add all
	#clean selection
	#curves smooth
end
prepc = UI::Command.new("Prep Choosing") {prep(true)}
prepc.small_icon = "skin/CSs.png"
prepc.large_icon = "skin/CS.png"
prepc.tooltip = "Splits all edges to be less than twice the length of smallest edge."
prepd = UI::Command.new("Prep Direct") {prep(false)}
prepd.small_icon = "skin/DSs.png"
prepd.large_icon = "skin/DS.png"
prepd.tooltip = "Splits all edges so that all groups have equal amounts of edges, or if only one group is selected it asks for amount to split each edge by."
skinc = UI::Command.new("Connect Choosing") {skin(true)}
skinc.small_icon = "skin/CCs.png"
skinc.large_icon = "skin/CC.png"
skinc.tooltip = "Connects the selected groups of entities."
skind = UI::Command.new("Connect Direct") {skin(false)}
skind.small_icon = "skin/DCs.png"
skind.large_icon = "skin/DC.png"
skind.tooltip = "Connects corresponding edges in between groups."
skin = SketchupExtension.new "Skin", "skin.rb"
skin.description = "A set of tools to connect sets of entities."
skin.version = "2.2.1"
skin.creator = "Darrel, aka ArchitectBoy"
skin.copyright = "2007, Darrel"
cleanc = UI::Command.new("Clean") {clean_selection(nil)}
cleanc.small_icon = "skin/cleanS.png"
cleanc.large_icon = "skin/clean.png"
cleanc.tooltip = "Removes all coplanar or empty selected edges."
if not (file_loaded? "skin.rb")
	add_separator_to_menu("Tools")
	dbtoolsm = UI.menu("Tools").add_submenu("D.B.Tools")
	dbtoolsm.add_item("Clean Selection") {clean_selection(nil)}
	dbtoolsm.add_item("Skin Direct") {skin(false)}
	dbtoolsm.add_item("Skin Choosing") {skin(true)}
	dbtoolsm.add_item("Prep Direct") {prep(false)}
	dbtoolsm.add_item("Prep Choosing") {prep(true)}
	Sketchup.register_extension skin
	DBTools = UI::Toolbar.new("Skin.rb")
	DBTools.add_item(prepc)
	DBTools.add_item(prepd)
	DBTools.add_item(skinc)
	DBTools.add_item(skind)
	DBTools.add_item(cleanc)
end
file_loaded("skin.rb")